///////////////////////////////////////////////////////////////////////
// WorkBeforeSleep.cpp
//
// Applied Data Systems
// ------------------------------------------------------------------
// Sample application for 720020-1167x SleepIntercept
//
// See SleepIntercept.h for a description and history
///////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "SleepIntercept.h"

void MyWorkProcedure();

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;

	RETAILMSG(TRUE, (_T("\r\n*** Starting WorkBeforeSleep Test ***\r\n")));

	SleepIntercept si;

	// set the work function
	si.SetWorkFunction(MyWorkProcedure);

	// enable the intercept
	if(!si.Enable())
		return -1;

	RETAILMSG(TRUE, (_T(" Waiting for RQONOFF interrupt...\r\n")));

	// a general message pump
	while ( GetMessage(&msg, NULL, 0, 0) != FALSE ) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// disable the interrupt
	si.Disable();

	return 0;
}

void MyWorkProcedure()
{
	// simulate some "work" to do before sleeping

	RETAILMSG(TRUE, (_T("\r\nDoing some work")));
	Sleep(1000);
	RETAILMSG(TRUE, (_T(".")));
	Sleep(1000);
	RETAILMSG(TRUE, (_T(".")));
	Sleep(1000);
	RETAILMSG(TRUE, (_T(".\r\n")));

	// when we exit this proc, the device will sleep
	RETAILMSG(TRUE, (_T("Done working, going to sleep.\r\nZzzzzzz\r\n")));
}

